/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include <ip.h>
#include <stdio.h>

typedef struct proce proce;
struct proce
{
	int pid;
	long ts;
};

void
usage(void)
{
	print("usage: [-m creatpnt] [-p port] [-x net] [-b hostb]"
		"[-d hostd] [-c parallel]\n");
	exits(0);
}

void
kill_proc(int p)
{
	char *e;
	int fd;

	e = mallocz(65, 2);
	snprintf(e, 64, "/proc/%d/ctl", p);

	fd = open(e, OWRITE);
	if(fd != -1)
	{
		write(fd, "kill", 4);
		close(fd);
	}
	free(e);

	return;
}
	

int
search_freep(proce *li, int l, int p)
{

	while(li[--l].pid != p && l >= 0);

	return l;
}

void
watch_proce(proce *li, int l)
{
	int ret;

	while(1)
	{
		sleep(1000);

		ret = -1;
		while(li[++ret].pid != 0 && ret < l)
			if(time(0) - li[ret].pid > 2)
				kill_proc(li[ret].pid);
	}
	return;
}

uchar *
get_next(uchar *b, uchar *d)
{
	int i;
	uchar *ret;

	i = -1;

	while(++i < 4)
	{
		if(b[i] != d[i])
			break;
	}
	if(i >= 4)
		return nil;

	i = 3;
	do
	{
		b[i]++;
		if(b[i] < 255)
			break;
		b[i] = 0;
	} while(--i > -1);

	if(b[0] == 0)
		return nil;

	ret = malloc(sizeof(uchar) * 4);
	memcpy(ret, (int *)b, sizeof(uchar) * 4);

	return ret;
}

void
main(int argc, char *argv[])
{
	uint sock;
	char *hostb, *hostd, *nets, *port, *mntp;
	uchar *n, *j, *h;
	proce *l;
	int d, c, b, e;

	mntp = "/mnt/ftp";
	hostb = "127.0.0.1";
	hostd = "127.0.0.1";
	nets = "/net";
	port = "21";
	c = 0;
	d = 101;
	
	ARGBEGIN {
		case 'm':
			mntp = ARGF();
			break;
		case 'p':
			port = ARGF();
			break;
		case 'b':
			hostb = ARGF();
			break;
		case 'd':
			hostd = ARGF();
			break;
		case 'x':
			nets = ARGF();
			break;
		case 'c':
			d = atoi(ARGF());
			break;
		default:
			usage();
	} ARGEND;

	l = mallocz(sizeof(proce) * d, 2);
	memset(l, 0, sizeof(proce) * d);

	switch(e = rfork(RFPROC | RFNOWAIT | RFMEM))
	{
		case -1:
			perror("rfork");
			exits("rfork");
		case 0:
			watch_proce(l, d);
			break;
		default:
			break;
	}

	print("Starting scan from %s to %s in port %s\n", hostb, 
			hostd, port);

	h = mallocz(sizeof(uchar) * 4, 2);
	j = mallocz(sizeof(uchar) * 4, 2);
	v4parseip(h, hostb);
	v4parseip(j, hostd);

	chdir(mntp);

	hostb = mallocz(512, 2);
	while((n = get_next(h, j)) != nil)
	{
		snprintf(hostb, 512, "%s/tcp!%d.%d.%d.%d!%s", nets, n[0], n[1], n[2],
						n[3], port);
		b = search_freep(l, d, 0);
		if(b < 0)
			print("This shouldn't happen.\n");

		c++;
		switch(l[b].pid = fork())
		{	
			case -1:
				l[b].pid = 0;
				c--;
				break;
			case 0:
				sock = dial(hostb, 0, 0, 0);
				if(sock != -1)
					print("%s\n", hostb);
				exits(0);
			default:
				l[b].ts = time(0);
				break;
		}

		while(c >= d)
		{
			if((b = waitpid()) < 0)
				c = 0;

			l[search_freep(l, d, b)].pid = 0;
			kill_proc(b);
			c--;
		}

		free(h);
		h = n;
	}
	
	
	while(wait() != nil);
	kill_proc(e);

	free(hostb);
	free(h);
	free(j);
	free(l);

	exits(0);
}
